package connection;

import common.CommonVariables;
import gui.BlueMIDlet;
import java.io.IOException;
import javax.bluetooth.BluetoothStateException;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.LocalDevice;
import javax.bluetooth.RemoteDevice;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.microedition.io.StreamConnectionNotifier;
import javax.microedition.midlet.MIDlet;

/**
 * Server portion of the bluetooth communication part
 * 
 * @author sumanta
 */
public class BlueServer implements Runnable {

    private StreamConnection conn;
    private StreamConnectionNotifier notifier;
    private LocalDevice device;
    private static String serverUrl = "btspp://localhost:" + CommonVariables.MYUUID +
            ";name=rfcommtest;authorize=true";
    private BlueMIDlet parent;

    /**
     * constructor
     * init local device and enables it as a server
     * 
     * @param parent
     */
    public BlueServer(MIDlet parent) {
        this.parent = (BlueMIDlet) parent;
//        try {
//            /*
//             * get the instance of local device
//             */
//            device = LocalDevice.getLocalDevice();
//            device.setDiscoverable(DiscoveryAgent.GIAC);
//
//            //starting the connection notifier
//            notifier = (StreamConnectionNotifier) Connector.open(serverUrl);
//            System.out.println("server about to start..");
//        } catch (BluetoothStateException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
//        } catch (IOException e) {
//            // TODO Auto-generated catch block
//            e.printStackTrace();
//        }

    }

    /**
     * starts server connection as a seperate thread
     * if an incoming connection is received, establish that
     * and start game
     */
    public void run() {
        /*
         * In this class the service will be listening for incoming connections
         */
        //System.out.println("server is up");
        try {
            /*
             * get the instance of local device
             */
            device = LocalDevice.getLocalDevice();
            device.setDiscoverable(DiscoveryAgent.GIAC);

            //starting the connection notifier
            notifier = (StreamConnectionNotifier) Connector.open(serverUrl);
            //System.out.println("server about to start..");
            
            
            conn = notifier.acceptAndOpen();
            CommonVariables.conn = conn;
            System.out.println("connection found: " + conn);
            RemoteDevice remote = RemoteDevice.getRemoteDevice(conn);
            parent.getTxtConnection().setString(remote.getFriendlyName(true));
            parent.switchDisplayable(null, parent.getTxtConnection());

            new ReadingThread(parent).start();
            //I have received connection, so I am the master ;)
            CommonVariables.myTurn = true;
            CommonVariables.myName = "server";
            CommonVariables.myChar = 'X';

        } catch (IOException e) {
            System.out.println("problem in server connection");
            e.printStackTrace();
        }

    }
}
